module.exports = [
  'Chrome >= 109',
  'Edge >= 128',
  'Firefox >= 115',
  'iOS >= 15.6',
  'Safari >= 15.6',
  'ChromeAndroid >= 130',
  'FirefoxAndroid >= 130',
];

/*
  The above is generated via browserslist to comply with [RFC #685](https://rfcs.emberjs.com/id/0685-new-browser-support-policy)
  and [RFC #984](https://rfcs.emberjs.com/id/0984-update-browser-support-policy) by running the following command:

  `npx browserslist '>0.25%, Firefox ESR, last 1 Chrome version, last 1 Firefox version, last 1 Edge version, last 1 FirefoxAndroid version, last 1 ChromeAndroid version, not dead'`

  And then filtering out unsupported browsers.

  and_chr 130
  and_ff 130
  chrome 130
  chrome 129
  chrome 128
  chrome 127
  chrome 126
  chrome 125
  chrome 124
  chrome 109
  edge 130
  edge 129
  edge 128
  firefox 132
  firefox 130
  firefox 129
  firefox 128
  firefox 115
  ios_saf 18.0
  ios_saf 17.6-17.7
  ios_saf 17.5
  ios_saf 17.4
  ios_saf 16.6-16.7
  ios_saf 16.1
  ios_saf 15.6-15.8
  safari 17.6
  safari 17.5
  safari 16.6
*/
